package ex5;

public class ASCIINumber implements Drawable{

	private int digit;
	private Point leftTop;

        /**
         * Construit un chiffre représenté par une grille de caractères.
         *
         * @param digit      Le chiffre représenté
         * @param leftBottom Les coordonnées auxquelles le chiffre doit être
         *                   affiché
         */
	public ASCIINumber(int digit, Point leftBottom)
	{
		this.leftTop = leftBottom;

		if(digit<10 && digit >=0)
                {
			this.digit = digit;
                }
	}
	
        /**
         * Renvoie la couleur avec laquelle le chiffre est affiché.
         *
         * @return La couleur utilisée pour afficher le chiffre.
         */
	public char getColor()
	{
		return (""+digit).charAt(0);
	}

        /**
         * Détermine si ce chiffre occupe le point dont la coordonnée est
         * spécifiée.
         *
         * @param point La coordonnées à tester.
         * @return Renvoie true si la coordonnée spécifiée est occupée par le
         *         chiffre.
         */
	public boolean isOn(Point point)
	{
		int x = point.x;
		int y = point.y;
		int x2 = leftTop.x;
		int y2 = leftTop.y;
		if(x2<=x && x2+5>x && y2<=y && y2+3>y) {
			return DIGITS[digit][x-x2][y-y2];
		} else {
			return false;
		}
	}
	
	/**
         * Des matrices représentant les chiffres de 0 à 9
         */
	private static final boolean[][][] DIGITS =
        {
		// digit 0
		 {{false, true,  false},
		  {true,  false, true},
		  {true,  false, true},
		  {true,  false, true},
		  {false, true,  false},
		 },
		// digit 1
		 {{false, false, true},
		 {false,  true,  true},
		 {false,  false, true},
		 {false,  false, true},
		 {false,  false, true}
		 },
		 //digit 2
		 {
                 {true,true,true},
		 {false,false,true},
		 {false, true, true},
		 {true, false, false},
		 {true, true, true}	 
		 },
		 //digit 3
		 {
                 {true,true,true},
		 {false,false,true},
		 {false, true, true},
		 {false,false,true},
		 {true, true, true}	 
		 },
		 //digit 4
		 {
	     {false,false,true},
		 {false,true,true},
		 {true, true, true},
		 {false, false, true},
		 {false, false, true}	 
		 },
		 //digit 5
		 {
	     {true,true,true},
		 {true,false,false},
		 {false, true, true},
		 {false, false, true},
		 {true, true, true}	 
		 },
		 //digit 6
		 {
	     {false,true,true},
		 {true,false,false},
		 {true, true, true},
		 {true, false, true},
		 {true, true, true}	 
		 },
		 //digit 7
		 {
	     {true,true,true},
		 {false,false,true},
		 {false, true, false},
		 {true, false, false},
		 {true, false, false}	 
		 },
		 //digit 8
		 {
	     {true,true,true},
		 {true,false,true},
		 {true, true, true},
		 {true, false, true},
		 {true, true, true}	 
		 },
		 //digit 9
		 {
	     {true,true,true},
		 {true,false,true},
		 {true, true, true},
		 {false, false, true},
		 {true, true, true}	 
		 }
	    };
	
}
